//
// automatically generated by spin2cpp v1.91 on Tue Apr  7 20:00:34 2015
// spin2cpp --ccode --gas --main ColorPAL_sense.spin 
//

// ******************************************
// *  <<<<<  ColorPAL Driver Object  >>>>>  *
// *  Author: Phil Pilgrim                  *
// *  Copyright (c) 2009 Phil Pilgrim       *
// *  See end of file for terms of use.     *
// ******************************************
#include <propeller.h>
#include "ColorPAL.h"

#ifdef __GNUC__
#define INLINE__ static inline
#define Yield__() __asm__ volatile( "" ::: "memory" )
#define PostEffect__(X, Y) __extension__({ int32_t tmp__ = (X); (X) = (Y); tmp__; })
#else
#define INLINE__ static
static int32_t tmp__;
#define PostEffect__(X, Y) (tmp__ = (X), (X) = (Y), tmp__)
#define Yield__()
#define waitcnt(n) _waitcnt(n)
#define coginit(id, code, par) _coginit((unsigned)(par)>>2, (unsigned)(code)>>2, id)
#define cognew(code, par) coginit(0x8, (code), (par))
#define cogstop(i) _cogstop(i)
#endif

INLINE__ int32_t Min__(int32_t a, int32_t b) { return a < b ? a : b; }
INLINE__ int32_t Max__(int32_t a, int32_t b) { return a > b ? a : b; }
static  int32_t ColorPAL_hex3inp( ColorPAL *self );

int32_t ColorPAL_start(ColorPAL *self, int32_t cpal_pin)
{
  // Start the ColorPAL connectd to pin cpal_pin.
  if (self->started) {
    ColorPAL_stop(self);
  }
  { int32_t _fill__0001; int32_t *_ptr__0003 = (int32_t *)&self->wb[0]; int32_t _val__0002 = 255; for (_fill__0001 = 3; _fill__0001 > 0; --_fill__0001) {  *_ptr__0003++ = _val__0002; } };
  // Get ColorPAL I/O set up.
  basic_sio_start_explicit(&self->cpal, cpal_pin, cpal_pin, (OPEN | 0x1c20));
  basic_sio_Break(&self->cpal, 50);
  waitcnt((CNT + (CLKFREQ / 100)));
  // Program ColorPAL to continruously sample and report colors.
  basic_sio_str(&self->cpal, (int32_t)"= (00 $ m) !");
  self->started = -1;
  return 0;
}

int32_t ColorPAL_stop(ColorPAL *self)
{
  // Stops communication with the ColorPAL.
  if (self->started) {
    basic_sio_Break(&self->cpal, 50);
    basic_sio_stop(&self->cpal);
    self->started = 0;
  }
  return 0;
}

int32_t ColorPAL_getWhite(ColorPAL *self)
{
  int32_t	i;
  int32_t result = 0;
  // Get raw RGB, and use it to define "white".
  if ((result = ColorPAL_getRGBraw(self))) {
    ColorPAL_setWhite(self, (int32_t)(&self->rgb[0]));
    return (int32_t)(&self->rgb[0]);
  }
  return result;
}

int32_t ColorPAL_setWhite(ColorPAL *self, int32_t rgbaddr)
{
  // Set white value from current RGB values.
  memmove( (void *)&self->wb[0], (void *)rgbaddr, 4*(3));
  return (int32_t)(&self->wb[0]);
}

int32_t ColorPAL_getRGB(ColorPAL *self)
{
  int32_t	i;
  int32_t result = 0;
  // Get white-balanced RGB values.
  if ((result = ColorPAL_getRGBraw(self))) {
    for(i = 0; i <= 2; i = i + 1) {
      self->rgb[i] = Min__(((self->rgb[i] * 255) / (Max__(self->wb[i], 1))), 255);
    }
    return (int32_t)(&self->rgb[0]);
  }
  return result;
}

int32_t ColorPAL_getRGBraw(ColorPAL *self)
{
  int32_t	i;
  // Get raw RGB values from ColorPAL
  if (self->started) {
    // Flush the input buffer.
    basic_sio_flush(&self->cpal);
    while (!(basic_sio_in(&self->cpal) == '$')) {
      Yield__();
    }
    // Wait for "$" from ColorPAL.
    for(i = 0; i <= 2; i = i + 1) {
      // Read three hex numbers.
      self->rgb[i] = ColorPAL_hex3inp(self);
    }
    return (int32_t)(&self->rgb[0]);
  } else {
    return 0;
  }
}

static int32_t ColorPAL_hex3inp(ColorPAL *self)
{
  int32_t	c;
  int32_t value = 0;
  // Read 3-digit hex value from ColorPAL.
  value = 0;
  {
    int32_t _idx__0004;
    for(_idx__0004 = 1; _idx__0004 <= 3; _idx__0004 = _idx__0004 + 1) {
      c = basic_sio_in(&self->cpal);
      if ((c >= '0') && (c <= '9')) {
        c = c - '0';
      } else {
        c = c - 0x37;
      }
      value = (value << 4) | c;
    }
  }
  return value;
}

/* 

┌──────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────┐
│                                                   TERMS OF USE: MIT License                                                  │                                                            
├──────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────┤
│Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation    │ 
│files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy,    │
│modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software│
│is furnished to do so, subject to the following conditions:                                                                   │
│                                                                                                                              │
│The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.│
│                                                                                                                              │
│THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE          │
│WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR         │
│COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,   │
│ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                         │
└──────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────┘
 */
