//
// automatically generated by spin2cpp v1.91 on Tue Apr  7 20:00:34 2015
// spin2cpp --ccode --gas --main ColorPAL_sense.spin 
//

// Copyright (c) 2008 Philip C. Pilgrim
// (See end of file for terms of use.)
//
// -----------[ Description ]----------------------------------------------------
//
// This Propeller object provides buffered serial receive and unbuffered serial
// transmit on either a single pin or a pair of pins. Pins can be either open
// drain or bipolar-driven, mark-high (normal) or mark-low (inverted).
//
// -----------[ Revision History ]-----------------------------------------------
//
// 2009.12.9: Added output break capability and method.
//
// -----------[ Program ]--------------------------------------------------------
#include <propeller.h>
#include "basic_sio.h"

#ifdef __GNUC__
#define INLINE__ static inline
#define Yield__() __asm__ volatile( "" ::: "memory" )
#define PostEffect__(X, Y) __extension__({ int32_t tmp__ = (X); (X) = (Y); tmp__; })
#else
#define INLINE__ static
static int32_t tmp__;
#define PostEffect__(X, Y) (tmp__ = (X), (X) = (Y), tmp__)
#define Yield__()
#define waitcnt(n) _waitcnt(n)
#define coginit(id, code, par) _coginit((unsigned)(par)>>2, (unsigned)(code)>>2, id)
#define cognew(code, par) coginit(0x8, (code), (par))
#define cogstop(i) _cogstop(i)
#endif

INLINE__ int32_t Shr__(uint32_t a, uint32_t b) { return (a>>b); }
extern uint8_t _load_start_basic_sio_cog[];
__asm__(
"		.section .basic_sio.cog, \"ax\"\n"
"		.equ	buf_size, $200\n"
"		.equ	OPEN, $80000000\n"
"		.equ	INVERTED, $40000000\n"
"		.compress off\n"
"..start\n"
"\n"
"ser_inp\n"
"		mov	acc, PAR\n"
"		mov	enqaddr, acc\n"
"		add	acc, #2\n"
"		mov	deqaddr, acc\n"
"		add	acc, #2\n"
"		mov	bufaddr, acc\n"
"		test	flags, invert	wc\n"
"\n"
"start_bit\n"
"	if_nc 	waitpeq	_0, inp_mask\n"
"	if_c 	waitpne	_0, inp_mask\n"
"		mov	time, baud\n"
"		shr	time, #1\n"
"		add	time, CNT\n"
"		waitcnt	time, baud\n"
"		test	inp_mask, INA	wz\n"
"	if_z_eq_c 	jmp	#start_bit\n"
"		mov	bitcnt, #9\n"
"\n"
"start_bit.bitlp\n"
"		shr	acc, #1\n"
"		waitcnt	time, baud\n"
"		test	inp_mask, INA	wz\n"
"	if_nc 	muxnz	acc, #$100\n"
"	if_c 	muxz	acc, #$100\n"
"		djnz	bitcnt, #start_bit.bitlp\n"
"		tjnz	acc, #serin_done\n"
"		mov	time, break_thld\n"
"		rdbyte	addr, xmtbreak	wz\n"
"	if_nz 	mov	time, #0\n"
"\n"
"start_bit.breaklp\n"
"		test	inp_mask, INA	wz\n"
"	if_z_eq_c 	jmp	#serin_done\n"
"		djnz	time, #start_bit.breaklp\n"
"		clkset	reset\n"
"\n"
"serin_done\n"
"		rdbyte	addr, xmtbusy	wz\n"
"	if_nz 	jmp	#start_bit\n"
"		mov	addr, bufaddr\n"
"		add	addr, enq\n"
"		wrbyte	acc, addr\n"
"		mov	acc, enq\n"
"		add	acc, #1\n"
"		cmp	acc, buflen	wz\n"
"	if_z 	mov	acc, #0\n"
"		rdword	deq, deqaddr\n"
"		cmp	acc, deq	wz\n"
"	if_nz 	wrword	acc, enqaddr\n"
"	if_nz 	mov	enq, acc\n"
"		jmp	#start_bit\n"
"\n"
"_0\n"
"		.long	0\n"
"\n"
"break_thld\n"
"		.long	$c350\n"
"\n"
"reset\n"
"		.long	$80\n"
"\n"
"enq\n"
"		.long	0\n"
"\n"
"buflen\n"
"		.long	buf_size\n"
"\n"
"invert\n"
"		.long	INVERTED\n"
"\n"
"baud\n"
"		.long	(0 - 0)\n"
"\n"
"inp_mask\n"
"		.long	(0 - 0)\n"
"\n"
"flags\n"
"		.long	(0 - 0)\n"
"\n"
"xmtbusy\n"
"		.long	(0 - 0)\n"
"\n"
"xmtbreak\n"
"		.long	(0 - 0)\n"
"\n"
"time\n"
"		.res	1\n"
"\n"
"acc\n"
"		.res	1\n"
"\n"
"bitcnt\n"
"		.res	1\n"
"\n"
"deq\n"
"		.res	1\n"
"\n"
"addr\n"
"		.res	1\n"
"\n"
"enqaddr\n"
"		.res	1\n"
"\n"
"deqaddr\n"
"		.res	1\n"
"\n"
"bufaddr\n"
"		.res	1\n"
"		.compress default\n"
"		.text\n"

);
int32_t basic_sio_start(basic_sio *self)
{
  // Simplifed start routine for Propeller Backpack's 3-pin interface.
  return basic_sio_start_explicit(self, 27, 27, (0x2580 | OPEN));
}

int32_t basic_sio_start_explicit(basic_sio *self, int32_t rx_pin, int32_t tx_pin, int32_t baudrate)
{
  // rx_pin:   Pin number for receive data. -1 to disable receive.
  //
  // tx_pin:   Pin number for transmit data. -1 to disable transmit.
  //
  // baudrate: Actual baudrate in bps. Can be ORed with OPEN for
  //           open-drain mode with a pull-up/pull-down and/or
  //           INVERTED for mark-low polarity.
  //
  // rx_pin and tx_pin can be the same if OPEN is asserted.
  //
  // ------------------------- VERY IMPORTANT --------------------------
  //
  // On receive, if a break condition (low for normal, high for INVERTED)
  // exceeds 800_000 clocks, the entire chip is reset. This provides a
  // way to effect an external reset without requiring access to the
  // /RST pin.
  //
  // --------------------------------------------------------------------
  basic_sio_stop(self);
  ((int32_t *)&_load_start_basic_sio_cog[204])[0] = 1 << rx_pin;
  self->transmitting = -(tx_pin >= 0);
  self->out_pin = tx_pin;
  self->same_pin = -(rx_pin == tx_pin);
  self->xbaud = (((int32_t *)&_load_start_basic_sio_cog[200])[0] = CLKFREQ / (baudrate & 0x3fffffff));
  self->one_ms = CLKFREQ / 1000;
  ((int32_t *)&_load_start_basic_sio_cog[208])[0] = baudrate & 0xc0000000;
  self->out_invert = -(((*(int32_t *)&_load_start_basic_sio_cog[208]) & INVERTED) != 0);
  self->out_open = -(((*(int32_t *)&_load_start_basic_sio_cog[208]) & OPEN) != 0);
  ((int32_t *)&_load_start_basic_sio_cog[212])[0] = (int32_t)(&self->out_busy);
  ((int32_t *)&_load_start_basic_sio_cog[216])[0] = (int32_t)(&self->out_break);
  if (tx_pin >= 0) {
    if (self->out_open) {
      DIRA &= ~(1<<tx_pin);
      OUTA = ((OUTA & (~(1 << tx_pin))) | ((self->out_invert & 0x1) << tx_pin));
    } else {
      OUTA = ((OUTA & (~(1 << tx_pin))) | (((~self->out_invert) & 0x1) << tx_pin));
      DIRA = ((DIRA & (~(1 << tx_pin))) | (1 << tx_pin));
    }
  }
  self->enqueue = 0;
  self->dequeue = 0;
  if (rx_pin < 0) {
    return -1;
  } else {
    if ((rx_pin != tx_pin) || (self->out_open)) {
      return -((self->receiving = cognew((int32_t)(&(*(int32_t *)&_load_start_basic_sio_cog[0])), (int32_t)(&self->enqueue)) + 1) > 0);
    } else {
      return 0;
    }
  }
}

int32_t basic_sio_stop(basic_sio *self)
{
  // Halt both transmitting and receiving operations.  
  if (self->transmitting) {
    DIRA &= ~(1<<self->out_pin);
    self->transmitting = 0;
  }
  if (self->receiving) {
    cogstop((self->receiving - 1));
    self->receiving = 0;
  }
  return -1;
}

int32_t basic_sio_flush(basic_sio *self)
{
  // Flushes input buffer.
  self->dequeue = self->enqueue;
  return -1;
}

int32_t basic_sio_inbytes(basic_sio *self)
{
  // Return the number of bytes waiting in the input queue.
  return ((self->enqueue - self->dequeue) - (buf_size * -(self->enqueue < self->dequeue)));
}

int32_t basic_sio_in(basic_sio *self)
{
  int32_t rxbyte = 0;
  // Return the next byte from the input queue. Blocks if no
  // bytes are waiting.
  if (!(self->receiving)) {
    return 0;
  }
  while (self->enqueue == self->dequeue) {
    Yield__();
  }
  rxbyte = self->buffer[self->dequeue];
  self->dequeue = (self->dequeue + 1) % buf_size;
  return rxbyte;
}

int32_t basic_sio_str(basic_sio *self, int32_t stringptr)
{
  int32_t	Char;
  // Send a string to the serial output.
  {
    int32_t _idx__0005;
    int32_t _limit__0006 = strlen((char *) stringptr);
    for(_idx__0005 = 1; _idx__0005 <= _limit__0006; _idx__0005 = _idx__0005 + 1) {
      basic_sio_out(self, ((uint8_t *)(stringptr++))[0]);
    }
  }
  return 0;
}

int32_t basic_sio_out(basic_sio *self, int32_t txbyte)
{
  int32_t	timer;
  // Send a byte to the serial output. If the byte value is > 255,
  // assume it's a string address and proceed with str.
  if (txbyte > 255) {
    basic_sio_str(self, txbyte);
  } else {
    if (self->transmitting) {
      txbyte = (((txbyte | 0x300) << 2) ^ self->out_invert) ^ self->out_open;
      self->out_busy = self->same_pin;
      timer = CNT;
      if (self->out_open) {
        {
          int32_t _idx__0007;
          for(_idx__0007 = 1; _idx__0007 <= 11; _idx__0007 = _idx__0007 + 1) {
            waitcnt((timer = timer + self->xbaud));
            DIRA = ((DIRA & (~(1 << self->out_pin))) | ((((txbyte = Shr__(txbyte, 1)) & 0x1) & 0x1) << self->out_pin));
          }
        }
      } else {
        {
          int32_t _idx__0008;
          for(_idx__0008 = 1; _idx__0008 <= 11; _idx__0008 = _idx__0008 + 1) {
            waitcnt((timer = timer + self->xbaud));
            OUTA = ((OUTA & (~(1 << self->out_pin))) | ((((txbyte = Shr__(txbyte, 1)) & 0x1) & 0x1) << self->out_pin));
          }
        }
      }
      self->out_busy = 0;
    }
  }
  return 0;
}

int32_t basic_sio_Break(basic_sio *self, int32_t time_ms)
{
  int32_t	brk_sig;
  // Send a break signal for time_ms. If time_ms < 0, set break on,
  // and leave it on. If time_ms == 0, turn break off.
  brk_sig = (-(time_ms == 0) ^ self->out_invert) ^ self->out_open;
  self->out_break = (self->out_busy = self->same_pin & -(time_ms != 0));
  if (self->out_open) {
    DIRA = ((DIRA & (~(1 << self->out_pin))) | ((brk_sig & 0x1) << self->out_pin));
  } else {
    OUTA = ((OUTA & (~(1 << self->out_pin))) | ((brk_sig & 0x1) << self->out_pin));
  }
  if (time_ms > 0) {
    waitcnt(((time_ms * self->one_ms) + CNT));
    if (self->out_open) {
      DIRA = ((DIRA & (~(1 << self->out_pin))) | (((~brk_sig) & 0x1) << self->out_pin));
    } else {
      OUTA = ((OUTA & (~(1 << self->out_pin))) | (((~brk_sig) & 0x1) << self->out_pin));
    }
    self->out_break = 0;
    self->out_busy = 0;
  }
  return 0;
}

// -----------[ TERMS OF USE ]---------------------------------------------------
//
// Permission is hereby granted, free of charge, to any person obtaining a copy of
// this software and associated documentation files (the "Software"), to deal in
// the Software without restriction, including without limitation the rights to use,
// copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the
// Software, and to permit persons to whom the Software is furnished to do so,
// subject to the following conditions: 
//
// The above copyright notice and this permission notice shall be included in all
// copies or substantial portions of the Software. 
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
// INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
// PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
// HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
// OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
// SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
