//
// automatically generated by spin2cpp v1.91 on Tue Apr  7 20:00:34 2015
// spin2cpp --ccode --gas --main ColorPAL_sense.spin 
//

// Object for ColorPAL.
// Object for PC serial I/O.
// ****************************************
// *  Simple_Numbers                      *
// *  Authors: Chip Gracey, Jon Williams  *
// *  Copyright (c) 2006 Parallax, Inc.   *
// *  See end of file for terms of use.   *
// ****************************************
//
// Provides simple numeric conversion methods; all methods return a pointer to
// a string.
//
// Updated... 29 APR 2006
#include <stdlib.h>
#include <propeller.h>
#include "simple_numbers.h"

#ifdef __GNUC__
#define INLINE__ static inline
#define PostEffect__(X, Y) __extension__({ int32_t tmp__ = (X); (X) = (Y); tmp__; })
#else
#define INLINE__ static
static int32_t tmp__;
#define PostEffect__(X, Y) (tmp__ = (X), (X) = (Y), tmp__)
#define waitcnt(n) _waitcnt(n)
#define coginit(id, code, par) _coginit((unsigned)(par)>>2, (unsigned)(code)>>2, id)
#define cognew(code, par) coginit(0x8, (code), (par))
#define cogstop(i) _cogstop(i)
#endif

INLINE__ int32_t Min__(int32_t a, int32_t b) { return a < b ? a : b; }
INLINE__ int32_t Max__(int32_t a, int32_t b) { return a > b ? a : b; }
INLINE__ int32_t Rotl__(uint32_t a, uint32_t b) { return (a<<b) | (a>>(32-b)); }
INLINE__ int32_t Rotr__(uint32_t a, uint32_t b) { return (a>>b) | (a<<(32-b)); }
INLINE__ int32_t Lookup__(int32_t x, int32_t b, int32_t a[], int32_t n) { int32_t i = (x)-(b); return ((unsigned)i >= n) ? 0 : (a)[i]; }

static  int32_t simple_numbers_clrstr( simple_numbers *self, int32_t strAddr, int32_t size);
static  int32_t simple_numbers_decstr( simple_numbers *self, int32_t value);
static  int32_t simple_numbers_hexstr( simple_numbers *self, int32_t value, int32_t digits);
static  int32_t simple_numbers_binstr( simple_numbers *self, int32_t value, int32_t digits);

int32_t simple_numbers_dec(simple_numbers *self, int32_t value)
{
  // Returns pointer to signed-decimal string
  // clear output string  
  simple_numbers_clrstr(self, (int32_t)(&self->nstr[0]), MAX_LEN);
  // return pointer to numeric string
  return simple_numbers_decstr(self, value);
}

int32_t simple_numbers_decf(simple_numbers *self, int32_t value, int32_t width)
{
  int32_t	t_val, field;
  // Returns pointer to signed-decimal, fixed-width (space padded) string
  simple_numbers_clrstr(self, (int32_t)(&self->nstr[0]), MAX_LEN);
  // qualify field width 
  width = Min__((Max__(1, width)), 0x3f);
  // work with absolute
  t_val = abs(value);
  // clear field
  field = 0;
  while (t_val > 0) {
    // count number of digits
    (field++);
    t_val = t_val / 10;
  }
  // min field width is 1
  field = Max__(field, 1);
  if (value < 0) {
    // if value is negative
    //   bump field for neg sign indicator
    (field++);
  }
  if (field < width) {
    // need padding?
    {
      int32_t _idx__0009;
      int32_t _limit__0010 = (width - field);
      for(_idx__0009 = 1; _idx__0009 <= _limit__0010; _idx__0009 = _idx__0009 + 1) {
        // yes
        //   pad with space(s)
        self->nstr[(self->idx++)] = ' ';
      }
    }
  }
  return simple_numbers_decstr(self, value);
}

int32_t simple_numbers_decx(simple_numbers *self, int32_t value, int32_t digits)
{
  int32_t	Div;
  // Returns pointer to zero-padded, signed-decimal string
  // -- if value is negative, field width is digits+1
  simple_numbers_clrstr(self, (int32_t)(&self->nstr[0]), MAX_LEN);
  digits = Min__((Max__(1, digits)), 10);
  if (value < 0) {
    // negative value?   
    //   yes, make positive
    value = -value;
    //   and print sign indicator
    self->nstr[(self->idx++)] = '-';
  }
  // initialize divisor
  Div = 1000000000;
  if (digits < 10) {
    // less than 10 digits?
    {
      int32_t _idx__0011;
      int32_t _limit__0012 = (10 - digits);
      for(_idx__0011 = 1; _idx__0011 <= _limit__0012; _idx__0011 = _idx__0011 + 1) {
        //   yes, adjust divisor
        Div = Div / 10;
      }
    }
  }
  // truncate unused digits
  value = value % (Div * 10);
  {
    int32_t _idx__0013;
    int32_t _limit__0014 = digits;
    for(_idx__0013 = 1; _idx__0013 <= _limit__0014; _idx__0013 = _idx__0013 + 1) {
      // convert digit to ASCII
      self->nstr[(self->idx++)] = (value / Div) + '0';
      // update value
      value = value % Div;
      // update divisor
      Div = Div / 10;
    }
  }
  return (int32_t)(&self->nstr[0]);
}

int32_t simple_numbers_hex(simple_numbers *self, int32_t value, int32_t digits)
{
  // Returns pointer to a digits-wide hexadecimal string
  simple_numbers_clrstr(self, (int32_t)(&self->nstr[0]), MAX_LEN);
  return simple_numbers_hexstr(self, value, digits);
}

int32_t simple_numbers_ihex(simple_numbers *self, int32_t value, int32_t digits)
{
  // Returns pointer to a digits-wide, indicated (with $) hexadecimal string
  simple_numbers_clrstr(self, (int32_t)(&self->nstr[0]), MAX_LEN);
  self->nstr[(self->idx++)] = '$';
  return simple_numbers_hexstr(self, value, digits);
}

int32_t simple_numbers_bin(simple_numbers *self, int32_t value, int32_t digits)
{
  // Returns pointer to a digits-wide binary string      
  simple_numbers_clrstr(self, (int32_t)(&self->nstr[0]), MAX_LEN);
  return simple_numbers_binstr(self, value, digits);
}

int32_t simple_numbers_ibin(simple_numbers *self, int32_t value, int32_t digits)
{
  // Returns pointer to a digits-wide, indicated (with %) binary string
  simple_numbers_clrstr(self, (int32_t)(&self->nstr[0]), MAX_LEN);
  // preface with binary indicator
  self->nstr[(self->idx++)] = '%';
  return simple_numbers_binstr(self, value, digits);
}

static int32_t simple_numbers_clrstr(simple_numbers *self, int32_t strAddr, int32_t size)
{
  // Clears string at strAddr
  // -- also resets global character pointer (idx)
  // clear string to zeros
  memset( (void *)strAddr, 0, 1*(size));
  // reset index
  self->idx = 0;
  return 0;
}

static int32_t simple_numbers_decstr(simple_numbers *self, int32_t value)
{
  int32_t	Div, z_pad;
  // Converts value to signed-decimal string equivalent
  // -- characters written to current position of idx
  // -- returns pointer to nstr
  if (value < 0) {
    // negative value? 
    //   yes, make positive
    value = -value;
    //   and print sign indicator
    self->nstr[(self->idx++)] = '-';
  }
  // initialize divisor
  Div = 1000000000;
  // clear zero-pad flag
  z_pad = 0;
  {
    int32_t _idx__0015;
    for(_idx__0015 = 1; _idx__0015 <= 10; _idx__0015 = _idx__0015 + 1) {
      if (value >= Div) {
        // printable character?
        //   yes, print ASCII digit
        self->nstr[(self->idx++)] = (value / Div) + '0';
        //   update value
        value = value % Div;
        //   set zflag
        z_pad = -1;
      } else {
        if ((z_pad) || (Div == 1)) {
          // printing or last column?
          self->nstr[(self->idx++)] = '0';
        }
      }
      Div = Div / 10;
    }
  }
  return (int32_t)(&self->nstr[0]);
}

static int32_t simple_numbers_hexstr(simple_numbers *self, int32_t value, int32_t digits)
{
  static int32_t look__0016[] = {48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 65, 66, 67, 68, 69, 70, };

  // Converts value to digits-wide hexadecimal string equivalent
  // -- characters written to current position of idx
  // -- returns pointer to nstr
  // qualify digits
  digits = Min__((Max__(1, digits)), 8);
  // prep most significant digit
  value = value << ((8 - digits) << 2);
  {
    int32_t _idx__0017;
    int32_t _limit__0018 = digits;
    for(_idx__0017 = 1; _idx__0017 <= _limit__0018; _idx__0017 = _idx__0017 + 1) {
      self->nstr[(self->idx++)] = Lookup__(((value = Rotl__(value, 4)) & 0xf), 0, look__0016, 16);
    }
  }
  return (int32_t)(&self->nstr[0]);
}

static int32_t simple_numbers_binstr(simple_numbers *self, int32_t value, int32_t digits)
{
  // Converts value to digits-wide binary string equivalent
  // -- characters written to current position of idx
  // -- returns pointer to nstr
  // qualify digits 
  digits = Min__((Max__(1, digits)), 32);
  // prep MSB
  value = value << (32 - digits);
  {
    int32_t _idx__0019;
    int32_t _limit__0020 = digits;
    for(_idx__0019 = 1; _idx__0019 <= _limit__0020; _idx__0019 = _idx__0019 + 1) {
      // move digits (ASCII) to string
      self->nstr[(self->idx++)] = ((value = Rotl__(value, 1)) & 0x1) + '0';
    }
  }
  return (int32_t)(&self->nstr[0]);
}

/* 

┌──────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────┐
│                                                   TERMS OF USE: MIT License                                                  │                                                            
├──────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────┤
│Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation    │ 
│files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy,    │
│modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software│
│is furnished to do so, subject to the following conditions:                                                                   │
│                                                                                                                              │
│The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.│
│                                                                                                                              │
│THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE          │
│WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR         │
│COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,   │
│ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                         │
└──────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────┘
 */
